package com.gic.auth.service.impl;

import com.gic.auth.dao.mapper.TabSysMenuRoleMapper;
import com.gic.auth.dto.MenuRoleDTO;
import com.gic.auth.entity.TabSysMenuRole;
import com.gic.auth.service.MenuRoleService;
import com.gic.commons.util.EntityUtil;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service("menuRoleService")
public class MenuRoleServiceImpl implements MenuRoleService{
    @Autowired
    private TabSysMenuRoleMapper tabSysMenuRoleMapper;

    @Override
    public void save(MenuRoleDTO dto) {
        tabSysMenuRoleMapper.insert(EntityUtil.changeEntityNew(TabSysMenuRole.class, dto));
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void deleteByRoleId(Integer roleId) {
        tabSysMenuRoleMapper.deleteByRoleId(roleId);
    }

    @Override
    public void insertForeach(List<MenuRoleDTO> list) {
        tabSysMenuRoleMapper.insertForeach(list);
    }

    @Override
    public List<MenuRoleDTO> listMenuRoleByRoleId(Integer roleId) {
        List<MenuRoleDTO> list = tabSysMenuRoleMapper.listMenuRoleByRoleId(roleId);
        if (CollectionUtils.isNotEmpty(list)) {
            return list;
        }
        return new ArrayList<>();
    }
}
